- name: "longhorn prerequisites"
  hosts: k3s_cluster
  become: "{{ become | default(True) }}"
  gather_facts: false
  pre_tasks:
    - name: "preflight"
      include_role:
        name: "framework/init"
  tasks:
    - name: Gather facts
      ansible.builtin.setup:

    - name: Install Longhorn Requirements
      apt:
        name:
          - open-iscsi
          - curl
          - util-linux
          - grep
          - mawk
          - libblkid1
          - multipath-tools
        state: present
        update_cache: yes
      when: ansible_distribution in ['Debian', 'Ubuntu']

    - name: Install Longhorn Requirements
      yum:
        name:
          - iscsi-initiator-utils
          - curl
          - multipath-tools
        state: present
        update_cache: yes
      when: ansible_distribution in ['CentOS', 'Red Hat Enterprise Linux']

    - name: Enable iscsid
      ansible.builtin.systemd:
        name: iscsid
        state: started
        enabled: yes

    - name: correct multipath config
      ansible.builtin.template:
        src: roles/kubernetes/longhorn/templates/multipath.conf.j2
        dest: /etc/multipath.conf
        owner: root
        group: root
        mode: "0644"
      register: multipathd_conf

    - name: Restart multipathd
      ansible.builtin.service:
        name: multipathd
        state: restarted
      when:
        - ansible_distribution in ['Debian', 'Ubuntu']
        - multipathd_conf.changed

- name: "loading plugin longhorn"
  hosts: localhost
  connection: local
  gather_facts: False
  pre_tasks:
    - name: "preflight"
      include_role:
        name: "framework/init"

    - name: "k8s preflight"
      include_role:
        name: "helpers/k8s_preflight"
  tasks:
    - name: loading
      include_role:
        name: "kubernetes/longhorn"
